package org.qatools.factory;

import java.util.Arrays;
import java.util.List;

import org.apache.log4j.Logger;
import org.qatools.util.ListUtil;

public class AllPairs extends QAToolsFactory {
    private static Logger logger = Logger.getLogger(AllPairs.class);


    // --------------------------------------------------------
    // ----- print
    // --------------------------------------------------------

    /**
     * 
     * @param allCombinations
     */
    public static void print(int[][] indexes) {
    	AllCombinations.print(indexes);
    }

    /**
     * 
     * @param allCombinations
     */
    public static void print(Object[][] allCombinations) {
    	AllCombinations.print(allCombinations);
    }

    // --------------------------------------------------------
    // ----- two params
    // --------------------------------------------------------

    // not supported
    // don't support two params - allPairs with 2 params is the same as allCombinations with 2 params

    
    // --------------------------------------------------------
    // ----- three params
    // --------------------------------------------------------

    /**
     * 
     * @param objs
     * @param objs2
     * @return
     */
    public static <A extends Object, B extends Object, C extends Object> Object[][] allPairs(A[] objs, B[] objs2, C[] objs3) {
    	return allPairs(Arrays.asList(objs), Arrays.asList(objs2), Arrays.asList(objs3));
    }
    
    /**
     * 
     * @param list
     * @param list2
     * @return
     */
    public static <A extends Object, B extends Object, C extends Object> Object[][] allPairs(List<A> list, List<B> list2, List<C> list3) {
    	return allPairs(list, list2, list3, null);
    }
	
    // --------------------------------------------------------
    // ----- four params
    // --------------------------------------------------------

    /**
     * 
     * @param objs
     * @param objs2
     * @return
     */
    public static <A extends Object, B extends Object, C extends Object, D extends Object> Object[][] allPairs(A[] objs, B[] objs2, C[] objs3, D[] objs4) {
    	return allPairs(Arrays.asList(objs), Arrays.asList(objs2), Arrays.asList(objs3), Arrays.asList(objs4));
    }
    
    /**
     * 
     * @param list
     * @param list2
     * @return
     */
    public static <A extends Object, B extends Object, C extends Object, D extends Object> Object[][] allPairs(List<A> list, List<B> list2, List<C> list3, List<D> list4) {
    	int[][] indexes = AllPairsHelper.allPairsIndexes(list, list2, list3, list4);
    	//AllPairs.print(indexes);
    	int rows = indexes.length;
    	int cols = indexes[0].length;
    	
    	Object[][] result = new Object[rows][cols];
    	for (int a=0; a<rows; a++) {
    		for (int b=0; b<cols; b++) {
    			Object o = null;
    			o = (b==0 ? list.get(indexes[a][b]) : o);
    			o = (b==1 ? list2.get(indexes[a][b]) : o);
    			o = (b==2 ? list3.get(indexes[a][b]) : o);
    			o = (b==3 ? list4.get(indexes[a][b]) : o);
    			result[a][b] = o;
    		}
    	}
    	return result;
    }


}