package org.qatools.validator;





/**
 * <pre>
 * Enum class for different print formats
 * 
 * The order in which formatting occurs is:
 * 
 * 			NUMBER_ERRORS - numbers each error (1), (2) etc
 * 			BR	- adds a "<br>" to each error so they format nicely in HTML
 * 			NEWLINE - adds a newline "\n" char to each error so they print nicely
 *         HASH_MARKS - wraps error & debug messages with hash marks for visual separation of errors & debugs
 * 
 * </pre>
 * 
 * @author Scott Wilson - QATools.org
 *
 */
public enum PrintFormat {
	NUMBER_ERRORS,
	NEWLINE,
	BR,
	HASH_MARKS
}
